"
I define the documentation for the Grafoscopio package.
"
Class {
	#name : #GrafoscopioDocs,
	#superclass : #GrafoscopioDocumentation,
	#category : #Grafoscopio
}

{ #category : #operation }
GrafoscopioDocs class >> devNotes [
	"I'm just an alias to ease the operation. I need to know wich is the index of the notebook
	I want to return, as defined on instance initialize method"
	| docs |
	docs := self newDefault. 
	^ (docs localPlace fullName, '/', (docs documents at: 5)) asFileReference.
]

{ #category : #initialization }
GrafoscopioDocs class >> initialize [
	self update
]

{ #category : #operation }
GrafoscopioDocs class >> manual [
	"I'm just an alias to ease the operation. I need to know wich is the index of the notebook
	I want to open, as defined on  method."
	| docs |
	docs := self newDefault. 
	^ (docs localPlace fullName, '/', (docs documents at: 2)) asFileReference.
]

{ #category : #operation }
GrafoscopioDocs class >> openPDFManual [
	"I open the documentation in PDF format."
	| pdfManual |
	pdfManual := FileLocator imageDirectory asFileReference / 'Grafoscopio/Docs/En/Books/Manual/manual.pdf'. 
	WebBrowser openOn: pdfManual fullName.
]

{ #category : #operation }
GrafoscopioDocs class >> tutorial [
	"I'm just an alias to ease the operation. I need to know wich is the index of the notebook
	I want to return, as defined on instance initialize method"
	| docs |
	docs := self newDefault. 
	^ (docs localPlace fullName, '/', (docs documents at: 1)) asFileReference.
]

{ #category : #initialization }
GrafoscopioDocs >> initialize [
	"I model the important documents that belong to the Grafoscopio documentation.
	When more documents become more mature and usable, I will include them."

	super initialize.
	name := 'grafoscopio'. 
	repository := (FossilRepo new remote: 'http://mutabit.com/repos.fossil/grafoscopio').
	localPlace := FileLocator workingDirectory asFileReference /'Grafoscopio'.
	self 
		addDocument: 'Docs/Es/Tutoriales/tutorial.ston';
		addDocument: 'Docs/En/Books/Manual/manual.ston';
		addDocument: 'uv/Docs/En/Books/Manual/manual.pdf';
		addDocument: 'Docs/En/Books/DataActivism/techniques-for-datactivism.ston';
		addDocument: 'Docs/En/dev-notes.ston';
		addDocument: 'Docs/En/Books/SpecIUFramework/spec-ui-framework.ston'.
]
